/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
\file terraAmazon/common/Enums.h

\brief Enumerations related to terraAmazon common package.
*/

#ifndef __TERRAAMAZON_COMMON_ENUMS_H
#define __TERRAAMAZON_COMMON_ENUMS_H

// TerraLib
#include <terralib/common/Static.h>

// STL
#include <string>

namespace ta
{
  namespace common
  {
    /*!
    \enum TerraAmazon User Types

    \brief Define the user types for terraAmazon Application
    */
    enum TaUserType
    {
      TA_GIS_USER,       //!< Use TA as a GIS
      TA_OPERATOR_USER,  //!< Use TA with Operator Permission
      TA_ADMIN_USER      //!< Use TA with Admin Permission
    };
  } // end namespace common
}   // end namespace ta

#endif // __TERRAAMAZON_COMMON_ENUMS_H

