/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/common/Version.cpp

  \brief Utility class for system versioning.
*/

// TerraAmazon
#include "../Version.h"
#include "Version.h"

// STL
#include <cassert>

int ta::common::Version::majorNumber()
{
  return TERRAAMAZON_VERSION_MAJOR;
}

int ta::common::Version::minorNumber()
{
  return TERRAAMAZON_VERSION_MINOR;
}

int ta::common::Version::patchNumber()
{
  return TERRAAMAZON_VERSION_PATCH;
}

std::string ta::common::Version::releaseStatus()
{
  assert(TERRAAMAZON_VERSION_STATUS);
  return std::string(TERRAAMAZON_VERSION_STATUS);
}

std::string ta::common::Version::buildDate()
{
  assert(__DATE__ " " __TIME__);
  return std::string(__DATE__ " " __TIME__);
}

std::string ta::common::Version::asString()
{
  assert(TERRAAMAZON_VERSION_STRING);
  return std::string(TERRAAMAZON_VERSION_STRING);
}

int ta::common::Version::asInt()
{
  return TERRAAMAZON_VERSION;
}

