/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/common/Version.h

  \brief Utility class for system versioning.
*/

#ifndef __TERRAAMAZON_COMMON_INTERNAL_VERSION_H
#define __TERRAAMAZON_COMMON_INTERNAL_VERSION_H

// TerraLib
#include "Config.h"

// STL
#include <string>

namespace ta
{
  namespace common
  {
    class Version
    {
      public:

        static int majorNumber();

        static int minorNumber();

        static int patchNumber();

        static std::string releaseStatus();

        static std::string buildDate();

        static std::string asString();

        static int asInt();

      private:

        Version();

        ~Version();
    };

  } // end namespace common
}   // end namespace te

#endif  // __TERRAAMAZON_COMMON_INTERNAL_VERSION_H



