/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file AboutDialog.h

  \brief A Qt dialog showing MGis about window.
*/

#ifndef __TERRAAMAZON_COMMON_QT_ABOUTDIALOG_H
#define __TERRAAMAZON_COMMON_QT_ABOUTDIALOG_H

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class AboutDialogForm; }

namespace ta
{
  namespace common
  {
    namespace qt
    {
      class AboutDialog : public QDialog
      {

        Q_OBJECT
          
      public:

        AboutDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~AboutDialog();

      private:

        std::auto_ptr<Ui::AboutDialogForm> m_ui;
      };
    } // end namespace qt
  }   // end namespace common
}     // end namespace ta

#endif  // __TERRAAMAZON_COMMON_QT_ABOUTDIALOG_H
