/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

#ifndef __TERRAAMAZON_COMMON_QT_CALCULATELAYERAREADIALOG_H
#define __TERRAAMAZON_COMMON_QT_CALCULATELAYERAREADIALOG_H

// TerraLib
#include <terralib/common/UnitOfMeasure.h>
#include <terralib/maptools/AbstractLayer.h>

// STL
#include <memory>

// Qt
#include <QDialog>

namespace Ui { class CalculateLayerAreaDialogForm; }

namespace ta
{
  namespace common
  {
    namespace qt
    {
      class CalculateLayerAreaDialog : public QDialog
      {
        Q_OBJECT

      public:

        CalculateLayerAreaDialog(QWidget* parent = 0);

        ~CalculateLayerAreaDialog();

      public:

        void setLayer(te::map::AbstractLayerPtr layer);

      protected slots:

        void onSrsToolButtonClicked();

        void onUnitComboBoxChanged(int index);

        void onCalculatePushButtonClicked();

      protected:

        void initUnitsOfMeasure();

        void setUnit(te::common::UnitOfMeasurePtr unit);

      private:

        std::unique_ptr<Ui::CalculateLayerAreaDialogForm> m_ui;

        te::map::AbstractLayerPtr m_layer;

        int m_layerSRID;

        int m_outputSRID;

      };
    } // end namespace qt
  }   // end namespace common
}     // end namespace ta



#endif  // __TERRAAMAZON_COMMON_QT_CALCULATELAYERAREADIALOG_H
