/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of
    this application.
    */

/*!
  \file CreateCellLayerUtils.h

  \brief ...
  */

#ifndef __TERRAAMAZON_MODEL_CREATECELLLAYERUTILS_H
#define __TERRAAMAZON_MODEL_CREATECELLLAYERUTILS_H

// TerraAmazon
#include "../../model/item/Catalog.h"

// Terralib
#include <terralib/dataaccess/datasource/DataSource.h>
#include <terralib/dataaccess/datasource/DataSourceInfo.h>
#include <terralib/maptools/AbstractLayer.h>

namespace te
{
  namespace gm
  {
    class Envelope;
  }
}

namespace ta
{
  namespace common
  {
      void CreateCellLayer(te::da::DataSourceInfoPtr targetDs, const std::string& newCellLayerName, const te::gm::Envelope& env, const double& res, const int& srid);

      void AdaptCellDataSet(te::da::DataSourcePtr source, const std::string& cellName);

      void PrepareCatalogCellLayer(te::da::DataSourceInfoPtr targetDs, const std::string& cellLayerName, const std::string& source, ta::model::Catalog* catalog);

  } // end namespace common
}   // end namespace ta


#endif  // __TERRAAMAZON_MODEL_CREATECELLLAYERUTILS_H
