/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

// TerraAmazon
#include "StatusBarInfoWidget.h"

// Qt
#include <QGridLayout>

ta::common::qt::StatusBarInfoWidget::StatusBarInfoWidget(QWidget* parent)
: QWidget(parent)
{
  buildUI();
}

ta::common::qt::StatusBarInfoWidget::~StatusBarInfoWidget()
{

}

void ta::common::qt::StatusBarInfoWidget::setWokspace(const std::string& name)
{
  if (name == "")
    m_wLine->clear();
  else
    m_wLine->setText(name.c_str());
}

void ta::common::qt::StatusBarInfoWidget::setServer(const std::string& name)
{
  if (name == "")
    m_sLine->clear();
  else
    m_sLine->setText(name.c_str());
}

void ta::common::qt::StatusBarInfoWidget::setUser(const std::string& name)
{
  if (name == "")
    m_uLine->clear();
  else
    m_uLine->setText(name.c_str());
}

void ta::common::qt::StatusBarInfoWidget::setProject(const std::string& name)
{
  if (name == "")
    m_pLine->clear();
  else
    m_pLine->setText(name.c_str());
}

void ta::common::qt::StatusBarInfoWidget::clear()
{
  m_wLine->clear();
  m_sLine->clear();;
  m_uLine->clear();;
  m_pLine->clear();;
}

void ta::common::qt::StatusBarInfoWidget::buildUI()
{
  QGridLayout* layout = new QGridLayout(this);
  layout->setContentsMargins(0, 0, 0, 0);

  // Workspace label
  QLabel* wLabel = new QLabel(this);
  wLabel->setText(tr("Workspace:"));
  layout->addWidget(wLabel, 0, 0);

  // Workspace line
  m_wLine = new QLineEdit(this);
  m_wLine->setFixedWidth(120);
  m_wLine->setAlignment(Qt::AlignHCenter);
  m_wLine->setEnabled(false);
  layout->addWidget(m_wLine, 0, 1);

  // Server label
  QLabel* sLabel = new QLabel(this);
  sLabel->setText(tr("Server:"));
  layout->addWidget(sLabel, 0, 2);

  // Server line
  m_sLine = new QLineEdit(this);
  m_sLine->setFixedWidth(120);
  m_sLine->setAlignment(Qt::AlignHCenter);
  m_sLine->setEnabled(false);
  layout->addWidget(m_sLine, 0, 3);

  // User label
  QLabel* uLabel = new QLabel(this);
  uLabel->setText(tr("User:"));
  layout->addWidget(uLabel, 0, 4);

  // User line
  m_uLine = new QLineEdit(this);
  m_uLine->setFixedWidth(120);
  m_uLine->setAlignment(Qt::AlignHCenter);
  m_uLine->setEnabled(false);
  layout->addWidget(m_uLine, 0, 5);

  // Project label
  QLabel* pLabel = new QLabel(this);
  pLabel->setText(tr("Project:"));
  layout->addWidget(pLabel, 0, 6);

  // Project line
  m_pLine = new QLineEdit(this);
  m_pLine->setFixedWidth(120);
  m_pLine->setAlignment(Qt::AlignHCenter);
  m_pLine->setEnabled(false);
  layout->addWidget(m_pLine, 0, 7);
}
