/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

#ifndef __TERRAAMAZON_COMMON_QT_STATUSBARINFOWIDGET_H
#define __TERRAAMAZON_COMMON_QT_STATUSBARINFOWIDGET_H

// STL
#include <string>

// Qt
#include <QLabel>
#include <QLineEdit>
#include <QWidget>

namespace ta
{
  namespace common
  {
    namespace qt
    {
      class StatusBarInfoWidget : public QWidget
      {
        Q_OBJECT

        public:

          StatusBarInfoWidget(QWidget* parent);

          ~StatusBarInfoWidget();

        public:

          void setWokspace(const std::string& name);

          void setServer(const std::string& name);

          void setUser(const std::string& name);

          void setProject(const std::string& name);

          void clear();

        protected:

          void buildUI();

        protected:

          QLineEdit* m_wLine;
          QLineEdit* m_sLine;
          QLineEdit* m_uLine;
          QLineEdit* m_pLine;
      };
    } // end namespace qt
  }   // end namespace common
}     // end namespace ta

#endif  // __TERRAAMAZON_COMMON_QT_STATUSBARINFOWIDGET_H
