/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

#ifndef __TERRAAMAZON_COMMON_QT_WELCOMEDIALOG_H
#define __TERRAAMAZON_COMMON_QT_WELCOMEDIALOG_H

// TerraAmazon
#include "../Enums.h"
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
#include <string>
#include <memory>

// Qt
#include <QDialog>

namespace Ui { class WelcomeDialogForm; }

namespace ta
{
  namespace workspace
  {
    namespace qt{ class ServerLoginDialog; }
  }

  namespace common
  {
    namespace qt
    {
      class WelcomeDialog : public QDialog
      {
        Q_OBJECT

      public:

        WelcomeDialog(QWidget* parent = 0);

        ~WelcomeDialog();

        ta::common::TaUserType getOption();

        bool showWelcomeDlg();

        void setServers(std::vector<te::da::DataSourceInfoPtr> servers);

        te::da::DataSourceInfoPtr getActiveServer();

        int getActiveUserId();

        protected slots :

        void onGisUserToolButtonClicked(bool);

        void onOperatorUserToolButtonClicked(bool);

        void onAdminUserToolButtonClicked(bool);

        void onCreateProjectToolButtonClicked(bool);

        void onsouDevelToolButtonClicked(bool);

      private:

        std::unique_ptr<Ui::WelcomeDialogForm>                m_ui;
        std::unique_ptr<ta::workspace::qt::ServerLoginDialog> m_loginDialog;
        ta::common::TaUserType                                m_option;
        te::da::DataSourceInfoPtr                             m_activeServer;
        int                                                   m_userId;
      };
    } // end namespace qt
  }   // end namespace common
}     // end namespace ta



#endif  // __TERRAAMAZON_COMMON_QT_WELCOMEDIALOG_H
