/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
\file terraAmazon/model/Enums.h

\brief Enumerations related to terraAmazon model.
*/

#ifndef __TERRAAMAZON_MODEL_ENUMS_H
#define __TERRAAMAZON_MODEL_ENUMS_H

// TerraLib
#include <terralib/common/Static.h>

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \enum SpatialOperation

    \brief Spatial Operations used to define rules in Terra Amazon model.
    */
    enum SpatialOperation
    {
      SO_DIFFERENCE = 0,    /*!< Difference   */
      SO_INTERSECTION = 1,  /*!< Intersection    */
      SO_UNION = 2,         /*!< Union  */
      SO_CLEAN = 3          /*!< Clean  */
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ENUMS_H

