/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

#ifndef __TERRAAMAZON_MODEL_GLOBALS_H
#define __TERRAAMAZON_MODEL_GLOBALS_H

// TerraLib
#include <terralib/common/Static.h>

// STL
#include <string>

namespace ta
{
  namespace model
  {
    class Globals : public te::common::Static
    {
      public:

        static const std::string sm_aoiLayer;
        static const std::string sm_catalog;
        static const std::string sm_cellLayer;
        static const std::string sm_cell;
        static const std::string sm_class;
        static const std::string sm_classClassgroup;
        static const std::string sm_classgroup;
        static const std::string sm_connectedUsers;
        static const std::string sm_group;
        static const std::string sm_groupPhase;
        static const std::string sm_groupUser;
        static const std::string sm_phase;
        static const std::string sm_preferences;
        static const std::string sm_process;
        static const std::string sm_project;
        static const std::string sm_projectScene;
        static const std::string sm_revision;
        static const std::string sm_rule;
        static const std::string sm_ruleRuleset;
        static const std::string sm_rulesLayerParams;
        static const std::string sm_rulesLayerColumn;
        static const std::string sm_ruleset;
        static const std::string sm_rulesetClass;
        static const std::string sm_rulesetProject;
        static const std::string sm_spatialOperation;
        static const std::string sm_scene;
        static const std::string sm_tagtask;
        static const std::string sm_task;
        static const std::string sm_tasklog;
        static const std::string sm_user;
        static const std::string sm_version;

        static const std::string sm_catalogAlias;
        static const std::string sm_processAlias;
        static const std::string sm_projectAlias;
        static const std::string sm_rulesetAlias;
        static const std::string sm_ruleRulesetAlias;
        static const std::string sm_rulesLayerColumnAlias;
        static const std::string sm_ruleAlias;
        static const std::string sm_taskAlias;
        static const std::string sm_taskLogAlias;
        static const std::string sm_userAlias;

        static const std::string sm_taUser;
        static const std::string sm_taPassword;
        static const std::string sm_taDefaultPassword;

        static const std::string sm_adminGroup;
        static const std::string sm_projectManagerGroup;
        static const std::string sm_operatorGroup;

        static const std::string sm_soDifference;
        static const std::string sm_soIntersection;
        static const std::string sm_soUnion;
        static const std::string sm_soClean;
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_PROJECT_H

