/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/AbstractFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_ABSTRACTFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_ABSTRACTFACADE_H

// TerraAmazon
#include "../item/AbstractItem.h"

// TerraLib
#include <terralib/dataaccess/datasource/DataSource.h>
namespace ta
{
  namespace model
  {

    class AbstractFacade
    {
      public:

        /*! Default Constructor */
        AbstractFacade(te::da::DataSourcePtr ds);

        /*! \brief Virtual destructor. */
        ~AbstractFacade();

        /*!
        \brief ...

        \return ...
        */
        std::string getDataSetName();

        /*!
        \brief ...

        \return ...
        */
        bool save(ta::model::AbstractItem* item);

        /*!
        \brief ...

        \return ...
        */
        bool save(ta::model::AbstractItem* item, te::da::DataSourceTransactor* transactor);

        /*!
        \brief ...

        \return ...
        */
        bool update(ta::model::AbstractItem* item);

        /*!
        \brief ...

        \return ...
        */
        bool remove(const int& id);

        /*!
        \brief ...

        \return ...
        */
        ta::model::AbstractItem* get(const int& id);

        /*!
        \brief ...

        \return ...
        */
        std::vector<ta::model::AbstractItem*> get();

        /*!
        \brief ...

        \return ...
        */
        virtual bool exists(const int& id);

        /*!
        \brief ...

        \return ...
        */
        std::string getErrorMessage();

      protected:

        /*!
        \brief ...

        \return ...
        */
        virtual bool checkProperties(ta::model::AbstractItem* item) = 0;

        /*!
        \brief ...

        \return ...
        */
        virtual bool hasDependecy(const int& id) = 0;

      protected:

        std::string m_datasetName;            //!< ...

        te::da::DataSourcePtr m_dataSource;   //!< ...

        std::string m_errorMessage;           //!< ...
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_ABSTRACTFACADE_H
