/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/AoiLayerFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_AOILAYERFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_AOILAYERFACADE_H

// TerraAmazon
#include "AbstractFacade.h"
#include "../Enums.h"
#include "../item/AoiLayer.h"

namespace ta
{
  namespace model
  {
    class AoiLayerFacade : public AbstractFacade
    {
    public:

      /*! Default Constructor */
      AoiLayerFacade(te::da::DataSourcePtr ds);

      /*! \brief Virtual destructor. */
      ~AoiLayerFacade();

    public:

      //bool remove(const int& projectId, const int& sceneId);

      bool save(ta::model::AbstractItem* item);

      const std::string getAoiIdColumn(const int& layerId);

    protected:

      bool checkProperties(ta::model::AbstractItem* item);

      bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_AOILAYERFACADE_H
