/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/GroupFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_GROUPFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_GROUPFACADE_H

// TerraAmazon
#include "AbstractFacade.h"
#include "../item/Phase.h"

namespace ta
{
  namespace model
  {
    class Group;

    class GroupFacade : public AbstractFacade
    {
      public:

        /*! Default Constructor */
        GroupFacade(te::da::DataSourcePtr ds);

        /*! \brief Virtual destructor. */
        ~GroupFacade();

      public:

        bool addAssociatePhase(const int &groupId, const int &phaseId);

        bool existsByName(const std::string& groupName);

        std::vector<Group*> getAllowedGroups();

        std::vector<Phase*> getAssociatedPhases(te::da::DataSourcePtr ds, int groupId);

        std::unique_ptr<ta::model::Group> getByName(const std::string& groupName);

        bool removeAssociatePhase(const int &groupId, const int &phaseId);

      protected:

        bool checkProperties(ta::model::AbstractItem* item);

        bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_GROUPFACADE_H
