/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/PhaseFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_PHASEFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_PHASEFACADE_H

// TerraAmazon
#include "AbstractFacade.h"
#include "../item/Phase.h"

namespace ta
{
  namespace model
  {
    class Phase;

    class PhaseFacade : public AbstractFacade
    {
    public:

      /*! Default Constructor */
      PhaseFacade(te::da::DataSourcePtr ds);

      /*! \brief Virtual destructor. */
      ~PhaseFacade();

      bool isAssociated(const int& phaseId);

      bool existsByDescription(const std::string& projDescription);

      std::vector<ta::model::Phase*> getNotAssociatedPhases();

    protected:

      bool checkProperties(ta::model::AbstractItem* item);

      bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_PHASEFACADE_H
