/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/ProjectSceneFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_PROJECTSCENEFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_PROJECTSCENEFACADE_H

// TerraAmazon
#include "AbstractFacade.h"
#include "../Enums.h"
#include "../item/ProjectScene.h"

namespace ta
{
  namespace model
  {
    class ProjectSceneFacade : public AbstractFacade
    {
    public:

      /*! Default Constructor */
      ProjectSceneFacade(te::da::DataSourcePtr ds);

      /*! \brief Virtual destructor. */
      ~ProjectSceneFacade();

    public:

      bool remove(const int& projectId, const int& sceneId);

      bool save(ta::model::AbstractItem* item);

      bool lock(const int& projectId, const int& sceneId, bool locked);

      bool isAssociated(const int& projectId, const int& sceneId);
      
      std::vector<int> getScenes(const int& projectId);

      std::vector<int> getProjects(const int& sceneId);

    protected:

      bool checkProperties(ta::model::AbstractItem* item);

      bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_PROJECTSCENEFACADE_H
