/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/RuleFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_RULEFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_RULEFACADE_H

// TerraAmazon
#include "AbstractFacade.h"

namespace ta
{
  namespace model
  {
    class Rule;

    class RuleFacade: public AbstractFacade
    {
      public:

        /*! Default Constructor */
        RuleFacade(te::da::DataSourcePtr ds);

        /*! \brief Virtual destructor. */
        ~RuleFacade();

      public:

        std::string createRuleName(const int& catalogId, const int& spatialOperationId);

        bool existsByName(const std::string& ruleName);

        bool existsByCatalogId(const int& catalogId);

        std::vector<ta::model::Rule*> getRulesWithIntersectionByRuleSet(const int &ruleSetId);

      protected:

        bool checkProperties(ta::model::AbstractItem* item);

        bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_RULEFACADE_H
