/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/RuleRuleSetFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_RULERULESETFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_RULERULESETFACADE_H

// TerraAmazon
#include "AbstractFacade.h"
#include "../Enums.h"
#include "../item/RuleRuleSet.h"

namespace ta
{
  namespace model
  {
    class RuleRuleSet;

    class RuleRuleSetFacade : public AbstractFacade
    {
    public:

      /*! Default Constructor */
      RuleRuleSetFacade(te::da::DataSourcePtr ds);

      /*! \brief Virtual destructor. */
      ~RuleRuleSetFacade();

    public:

      bool remove(const int& ruleId, const int& ruleSetId);

      bool save(ta::model::AbstractItem* item);

      bool save(ta::model::AbstractItem* item, te::da::DataSourceTransactor* transactor);

      bool hasRuleDependecy(const int& ruleId);

      std::vector<int> getRules(const int& ruleSetId);

      std::vector<ta::model::RuleRuleSet*> getByRuleSetId(const int& ruleSetId);

    protected:

      bool checkProperties(ta::model::AbstractItem* item);

      bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_RULERULESETFACADE_H
