/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/RulesLayerColumnFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_RULESLAYERCOLUMNFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_RULESLAYERCOLUMNFACADE_H

// TerraAmazon
#include "AbstractFacade.h"

namespace ta
{
  namespace model
  {
    class RulesLayerColumn;

    class RulesLayerColumnFacade : public AbstractFacade
    {
    public:

      /*! Default Constructor */
      RulesLayerColumnFacade(te::da::DataSourcePtr ds);

      /*! \brief Virtual destructor. */
      ~RulesLayerColumnFacade();

    public:

      ta::model::RulesLayerColumn* getByRuleSetIdAndColumnOut(const int& ruleSetId, const std::string& columnOut);

      std::vector<ta::model::RulesLayerColumn*> getByRuleSetIdAndRuleId(const int& ruleSetId, const int& ruleId);

    protected:

      bool checkProperties(ta::model::AbstractItem* item);

      bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_RULESLAYERCOLUMNFACADE_H
