/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/SceneFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_SCENEFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_SCENEFACADE_H

// TerraAmazon
#include "AbstractFacade.h"
#include "../../model/item/AoiLayer.h"


namespace ta
{
  namespace model
  {
    class Scene;

    class SceneFacade: public AbstractFacade
    {
      public:

        /*! Default Constructor */
        SceneFacade(te::da::DataSourcePtr ds);

        /*! \brief Virtual destructor. */
        ~SceneFacade();

        bool isSceneLocked(const int& sceneId, const int& projectId, bool& lockState);

        const std::string getAoiIdColumn(const int& sceneId);

        std::auto_ptr<te::gm::Geometry> getAiGeometries(const int& processId);

        std::auto_ptr<ta::model::AoiLayer> getAoiLayer(int aoiLayerId);

      protected:

        bool checkProperties(ta::model::AbstractItem* item);

        bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_SCENEFACADE_H
