/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/TaskFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_TASKFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_TASKFACADE_H

// TerraAmazon
#include "AbstractFacade.h"

namespace ta
{
  namespace model
  {
    class Task;

    class TaskFacade: public AbstractFacade
    {
      public:

        /*! Default Constructor */
        TaskFacade(te::da::DataSourcePtr ds);

        /*! \brief Virtual destructor. */
        ~TaskFacade();

        std::auto_ptr<te::da::DataSet> getTaskControl(const int& projId);

        bool loadTask(const int& projId, const int& phaseId, const int& userId, const int& sceneId);

        ta::model::Scene* getScene(Task* task);

      protected:

        bool checkProperties(ta::model::AbstractItem* item);

        bool hasDependecy(const int& id);
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_TASKFACADE_H
