/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/facade/TaskLogFacade.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_FACADE_TASKLOGFACADE_H
#define __TERRAAMAZON_MODEL_FACADE_TASKLOGFACADE_H

// TerraAmazon
#include "AbstractFacade.h"

namespace ta
{
  namespace model
  {
    class TaskLog;

    class TaskLogFacade: public AbstractFacade
    {
      public:

        /*! Default Constructor */
        TaskLogFacade(te::da::DataSourcePtr ds);

        /*! \brief Virtual destructor. */
        ~TaskLogFacade();

        TaskLog* getLastTaskLog(const int& taskId);

        bool updateLogTimer(const int& taskLogId, unsigned int& valueToIncreaseInSec);

      protected:

        bool checkProperties(ta::model::AbstractItem* item);

        bool hasDependecy(const int& id);

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_FACADE_TASKLOGFACADE_H
