/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/AbstractItemFactory.cpp

\brief ...
*/

// TerraAmazon
#include "AbstractItemFactory.h"
#include "../item/AbstractItem.h"


ta::model::AbstractItem* ta::model::AbstractItemFactory::make(const std::string& type)
{
  return te::common::AbstractFactory<ta::model::AbstractItem, std::string>::make(type);
}

ta::model::AbstractItem* ta::model::AbstractItemFactory::make(const std::string& type, te::da::DataSet* ds)
{
  te::common::AbstractFactory<AbstractItem, std::string>::dictionary_type& d = te::common::AbstractFactory<AbstractItem, std::string>::getDictionary();

  AbstractItemFactory* f = static_cast<AbstractItemFactory*>(d.find(type));

  if (f == 0)
    throw;

  AbstractItem* ai = f->create(ds);

  return ai;
}

ta::model::AbstractItemFactory::~AbstractItemFactory()
{

}

ta::model::AbstractItemFactory::AbstractItemFactory(const std::string& factoryKey)
  : te::common::AbstractFactory<ta::model::AbstractItem, std::string>(factoryKey)
{

}
