/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/ClassFactory.h

\brief ...
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_CLASSFACTORY_H
#define __TERRAAMAZON_MODEL_ITEM_CLASSFACTORY_H

// TerraAmazon
#include "AbstractItemFactory.h"

namespace ta
{
  namespace model
  {
    class ClassFactory : public AbstractItemFactory
    {
      
      public:

        static void initialize();

        static void finalize();

        std::string getType() const;

        ~ClassFactory();

      protected:

        ClassFactory();

        ta::model::AbstractItem* build();

        ta::model::AbstractItem* create(te::da::DataSet* ds = 0);

      private:

        static ClassFactory* sm_factory;
    };
  }
}

#endif // __TERRAAMAZON_MODEL_ITEM_CLASSFACTORY_H
