/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/GroupFactory.h

\brief ...
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_GROUPFACTORY_H
#define __TERRAAMAZON_MODEL_ITEM_GROUPFACTORY_H

// TerraAmazon
#include "AbstractItemFactory.h"

namespace ta
{
  namespace model
  {
    class GroupFactory : public AbstractItemFactory
    {
     
      public:

        static void initialize();

        static void finalize();

        std::string getType() const;

        ~GroupFactory();

      protected:

        GroupFactory();

        ta::model::AbstractItem* build();

        ta::model::AbstractItem* create(te::da::DataSet* ds = 0);

      private:

        static GroupFactory* sm_factory;
    };
  }
}


#endif // __TERRAAMAZON_MODEL_ITEM_GROUPFACTORY_H

