/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/RuleRuleSetFactory.h

\brief ...
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_RULERULESETFACTORY_H
#define __TERRAAMAZON_MODEL_ITEM_RULERULESETFACTORY_H

// TerraAmazon
#include "AbstractItemFactory.h"

namespace ta
{
  namespace model
  {
    class RuleRuleSetFactory : public AbstractItemFactory
    {
      
      public:

        static void initialize();

        static void finalize();

        std::string getType() const;

        ~RuleRuleSetFactory();

      protected:

        RuleRuleSetFactory();

        ta::model::AbstractItem* build();

        ta::model::AbstractItem* create(te::da::DataSet* ds = 0);

      private:

        static RuleRuleSetFactory* sm_factory;
    };
  }
}

#endif // __TERRAAMAZON_MODEL_ITEM_RULERULESETFACTORY_H
