/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/AbstractItem.cpp

\brief ...
*/

// TerraAmazon
#include "AbstractItem.h"

ta::model::AbstractItem::AbstractItem()
 : m_id(-1)
{

}

ta::model::AbstractItem::~AbstractItem()
{

}

void ta::model::AbstractItem::setId(const int& id)
{
  m_id = id;
}

int ta::model::AbstractItem::getId() const
{
  return m_id;
}

void ta::model::AbstractItem::addProperty(const std::string& name, ItemProperties* prop, ItemPropertyVector& vec)
{
  for (std::size_t i = 0; i < vec.size(); ++i)
  {
    if (vec[i]->getName() == name)
    {
      delete vec[i];

      vec[i] = prop;

      return;
    }
  }

  vec.push_back(prop);
}
