/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/AbstractItem.h

\brief ...
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_ABSTRACTITEM_H
#define __TERRAAMAZON_MODEL_ITEM_ABSTRACTITEM_H

// TerraAmazon
#include "ItemProperties.h"

namespace ta
{
  namespace model
  {
    class AbstractItem
    {
      public:

        /*Default Constructor*/
        AbstractItem();

        /*Default Virtual Destructor*/
        virtual ~AbstractItem();

      public:

        virtual ItemPropertyVector toProperties() = 0;

        /*  */
        void setId(const int& id);

        int getId() const;

      protected:

        /*!
        \brief ...

        \return ...
        */
        void addProperty(const std::string& name, ItemProperties* prop, ItemPropertyVector& vec);

      protected:

        int m_id; //!< Attribute used to identify the item
    };
  }
}

#endif // __TERRAAMAZON_MODEL_ITEM_ABSTRACTITEM_H
