/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/CellLayer.cpp

\brief This file defines the Cell Layer model.
*/

// TerraAmazon
#include "CellLayer.h"

// TerraLib

const std::string ta::model::CellLayer::sm_catalogId("catalog_id");
const std::string ta::model::CellLayer::sm_name("name");
const std::string ta::model::CellLayer::sm_resolution("resolution");
const std::string ta::model::CellLayer::sm_active("active");

ta::model::CellLayer::CellLayer()
  : m_catalogId(-1),
    m_resolution(-1.f),
    m_active(false)
{
}

ta::model::CellLayer::~CellLayer()
{
}

int ta::model::CellLayer::getCatalogId()
{
  return m_catalogId;
}

std::string ta::model::CellLayer::getName()
{
  return m_name;
}

double ta::model::CellLayer::getResolution()
{
  return m_resolution;
}

bool ta::model::CellLayer::getActive()
{
  return m_active;
}

void ta::model::CellLayer::setCatalogId(const int& catalogId)
{
  m_catalogId = catalogId;
}

void ta::model::CellLayer::setName(const std::string& name)
{
  m_name = name;
}

void ta::model::CellLayer::setResolution(const double& resolution)
{
  m_resolution = resolution;
}

void ta::model::CellLayer::setActive(const bool& active)
{
  m_active = active;
}