/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/CellLayer.h

\brief This file defines the Cell Layer model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_CELLLAYER_H
#define __TERRAAMAZON_MODEL_ITEM_CELLLAYER_H

// TerraLib

// TerraAmazon

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class CellLayer

    \brief This class defines the cell Layer model.

    \ingroup model
    */
    class CellLayer
    {
    public:

      static const std::string sm_catalogId;           //!< ...
      static const std::string sm_name;                //!< ...
      static const std::string sm_resolution;          //!< ...
      static const std::string sm_active;              //!< ...

    public:

      /*! \brief Default constructor  */
      CellLayer();

      /*! \brief Default destructor  */
      ~CellLayer();

    public:

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      int getCatalogId();

      /*!
      \brief ...

      \return ...
      */
      std::string getName();

      /*!
      \brief ...

      \return ...
      */
      double getResolution();

      /*!
      \brief ...

      \return ...
      */
      bool getActive();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setCatalogId(const int& catalogId);

      /*!
      \brief ...

      \param ...
      */
      void setName(const std::string& name);

      /*!
      \brief ...

      \param ...
      */
      void setResolution(const double& resolution);

      /*!
      \brief ...

      \param ...
      */
      void setActive(const bool& active);

      //@}

    private:

      int           m_catalogId;        //!< ...
      std::string   m_name;             //!< ...
      double        m_resolution;       //!< ...
      bool          m_active;           //!< ...

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_CELLLAYER_H

