/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/CellLock.cpp

\brief This file defines the Cell Lock model.
*/

// TerraAmazon
#include "CellLock.h"

// TerraLib

const std::string ta::model::CellLock::sm_userName("user_name");
const std::string ta::model::CellLock::sm_cellOid("cell_oid");
const std::string ta::model::CellLock::sm_dateTime("date_time");
const std::string ta::model::CellLock::sm_ProjectName("project_name");

ta::model::CellLock::CellLock()
  : m_dateTime(0)
{
}

ta::model::CellLock::~CellLock()
{
}

std::string ta::model::CellLock::getUserName()
{
  return m_userName;
}

std::string ta::model::CellLock::getCellOid()
{
  return m_cellOid;
}

te::dt::TimeInstant* ta::model::CellLock::getDateTime()
{
  return m_dateTime;
}

std::string ta::model::CellLock::getProjetName()
{
  return m_projectName;
}

void ta::model::CellLock::setUserName(const std::string& userName)
{
  m_userName = userName;
}

void ta::model::CellLock::setCellOid(const std::string& cellOid)
{
  m_cellOid = cellOid;
}

void ta::model::CellLock::setDateTime(te::dt::TimeInstant* dateTime)
{
  m_dateTime = dateTime;
}

void ta::model::CellLock::setProjetName(const std::string& projectName)
{
  m_projectName = projectName;
}