/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/CellLock.h

\brief This file defines the Cell Lock model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_CELLLOCK_H
#define __TERRAAMAZON_MODEL_ITEM_CELLLOCK_H

// TerraLib
#include <terralib/datatype/TimeInstant.h>

// TerraAmazon

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class CellLock

    \brief This class defines the cell Lock model.

    \ingroup model
    */
    class CellLock
    {
    public:

      static const std::string sm_userName;           //!< ...
      static const std::string sm_cellOid;            //!< ...
      static const std::string sm_dateTime;           //!< ...
      static const std::string sm_ProjectName;        //!< ...

    public:

      /*! \brief Default constructor  */
      CellLock();

      /*! \brief Default destructor  */
      ~CellLock();

    public:

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      std::string getUserName();

      /*!
      \brief ...

      \return ...
      */
      std::string getCellOid();

      /*!
      \brief ...

      \return ...
      */
      te::dt::TimeInstant* getDateTime();

      /*!
      \brief ...

      \return ...
      */
      std::string getProjetName();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setUserName(const std::string& userName);

      /*!
      \brief ...

      \param ...
      */
      void setCellOid(const std::string& cellOid);

      /*!
      \brief ...

      \param ...
      */
      void setDateTime(te::dt::TimeInstant* dateTime);

      /*!
      \brief ...

      \param ...
      */
      void setProjetName(const std::string& projectName);

      //@}

    private:

      std::string           m_userName;        //!< ...
      std::string           m_cellOid;         //!< ...
      te::dt::TimeInstant*  m_dateTime;        //!< ...
      std::string           m_projectName;     //!< ...

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_CELLLOCK_H

