/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/Class.h

\brief This file defines the Class model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_CLASS_H
#define __TERRAAMAZON_MODEL_ITEM_CLASS_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class Project

    \brief This class defines the class model.

    \ingroup model

    \sa AbstractItem
    */
    class Class : public AbstractItem
    {
      public:

        static const std::string sm_id;           //!< ...
        static const std::string sm_name;         //!< ...
        static const std::string sm_description;  //!< ...
        static const std::string sm_style;        //!< ...

      public:

        /*! \brief Default constructor  */
        Class();

        /*! \brief Default destructor  */
        ~Class();

      public:

        ItemPropertyVector toProperties();

      public:

        /** @name Getters
        */
        //@{

        /*!
        \brief ...

        \return ...
        */
        std::string getName();

        /*!
        \brief ...

        \return ...
        */
        std::string getDescription();

        /*!
        \brief ...

        \return ...
        */
        std::string getStyle();


        //@}

        /** @name Setters
        */
        //@{

        /*!
        \brief ...

        \param ...
        */
        void setName(const std::string& name);

        /*!
        \brief ...

        \param ...
        */
        void setDescription(const std::string& desc);

        /*!
        \brief ...

        \param ...
        */
        void setStyle(const std::string& style);

      //@}

      private:

        std::string               m_name;     //!< ...
        std::string               m_desc;     //!< ...
        std::string               m_style;    //!< ...
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_CLASS_H

