/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/Group.h

\brief This file defines the Group model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_GROUP_H
#define __TERRAAMAZON_MODEL_ITEM_GROUP_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class Group

    \brief This class defines the group model.

    \ingroup model

    \sa AbstractItem
    */
    class Group : public AbstractItem
    {
    public:

      static const std::string sm_id;          //!< ...
      static const std::string sm_name;        //!< ...
      static const std::string sm_privileges;  //!< ...

    public:

      /*! \brief Default constructor  */
      Group();

      /*! \brief Default destructor  */
      ~Group();

    public:

      ItemPropertyVector toProperties();

    public:

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      std::string getName();

      /*!
      \brief ...

      \return ...
      */
      int getPrivileges();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setName(const std::string& name);

      /*!
      \brief ...

      \param ...
      */
      void setPrivileges(const int& privileges);

      //@}

    private:

      std::string       m_name;           //!< ...
      int               m_privileges;     //!< ...
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_GROUP_H

