/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
\file terraamazon/model/item/ItemProperties.cpp

\brief ...
*/

#include "ItemProperties.h"

ta::model::ItemProperties::ItemProperties(const std::string& name)
  : m_name(name),
  m_data(0),
  m_property(0)
{

}

ta::model::ItemProperties::~ItemProperties()
{
  delete m_data;
  delete m_property;
}

void ta::model::ItemProperties::setProperty(te::dt::Property* prop)
{
  m_property = prop;
}

void ta::model::ItemProperties::setData(te::dt::AbstractData* data)
{
  m_data = data;
}

void ta::model::ItemProperties::setName(const std::string& name)
{
  m_name = name;
}

te::dt::Property* ta::model::ItemProperties::getProperty()
{
  return m_property;
}

te::dt::AbstractData* ta::model::ItemProperties::getData()
{
  return m_data;
}

std::string ta::model::ItemProperties::getName()
{
  return m_name;
}