/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
\file terraamazon/model/item/ItemProperties.h

\brief ...
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_ITEMPROPERTIES_H
#define __TERRAAMAZON_MODEL_ITEM_ITEMPROPERTIES_H

// TerraLib
#include <terralib/datatype/AbstractData.h>
#include <terralib/datatype/Property.h>

// STL
#include <string>
#include <vector>

namespace ta
{
  namespace model
  {
    /*!
      \class ItemProperties

      \brief ...

      \ingroup model

      \sa AbstractData, Property
    */
    class ItemProperties
    {
      public:

        /*!
        \brief ...

        \return ...
        */
        ItemProperties(const std::string& name);

        /*!
        \brief ...

        \return ...
        */
        ~ItemProperties();

      public:

        /*!
        \brief ...

        \return ...
        */
        void setProperty(te::dt::Property* prop);

        /*!
        \brief ...

        \return ...
        */
        void setData(te::dt::AbstractData* data);

        /*!
        \brief ...

        \return ...
        */
        void setName(const std::string& name);

        /*!
        \brief ...

        \return ...
        */
        te::dt::Property* getProperty();

        /*!
        \brief ...

        \return ...
        */
        te::dt::AbstractData* getData();

        /*!
        \brief ...

        \return ...
        */
        std::string getName();

      private:

        std::string           m_name;     //!< ...
        te::dt::AbstractData* m_data;     //!< ...
        te::dt::Property*     m_property; //!< ...
    };

    typedef std::vector<ItemProperties*>ItemPropertyVector; ///< ...

  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_ITEMPROPERTIES_H
