/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/Phase.h

\brief This file defines the Phase model.
*/

// TerraAmazon
#include "ItemProperties.h"
#include "Phase.h"

// TerraLib
#include <terralib/datatype/SimpleData.h>
#include <terralib/datatype/StringProperty.h>

const std::string ta::model::Phase::sm_id("id");
const std::string ta::model::Phase::sm_description("description");

ta::model::Phase::Phase()
: AbstractItem(),
m_description("")
{

}

ta::model::Phase::~Phase()
{
}

ta::model::ItemPropertyVector ta::model::Phase::toProperties()
{
  ta::model::ItemPropertyVector ipv;

  {
    te::dt::Property* p = new te::dt::StringProperty(ta::model::Phase::sm_description, te::dt::VAR_STRING, 255);
    te::dt::AbstractData* ad = new te::dt::SimpleData<std::string, te::dt::STRING_TYPE>(m_description);
    ta::model::ItemProperties* mep = new ta::model::ItemProperties(ta::model::Phase::sm_description);
    mep->setProperty(p);
    mep->setData(ad);

    addProperty(ta::model::Phase::sm_description, mep, ipv);
  }

  return ipv;
}

std::string ta::model::Phase::getDescription()
{
  return m_description;
}

void ta::model::Phase::setDescription(const std::string& description)
{
  m_description = description;
}