/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/Phase.h

\brief This file defines the Phase model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_PHASE_H
#define __TERRAAMAZON_MODEL_ITEM_PHASE_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class Phase

    \brief This class defines the phase model.

    \ingroup model

    \sa AbstractItem
    */
    class Phase : public AbstractItem
    {
    public:

      static const std::string sm_id;               //!< ...
      static const std::string sm_description;      //!< ...

    public:

      /*! \brief Default constructor  */
      Phase();

      /*! \brief Default destructor  */
      ~Phase();

    public:

      ItemPropertyVector toProperties();

    public:

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      std::string getDescription();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setDescription(const std::string& description);

      //@}

    private:

      std::string               m_description;     //!< ...
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_PHASE_H

