/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/Process.h

\brief This file defines the Process model.
*/

// TerraAmazon
#include "ItemProperties.h"
#include "Process.h"

// TerraLib
#include <terralib/datatype/DateTimeInstant.h>
#include <terralib/datatype/DateTimeProperty.h>
#include <terralib/datatype/SimpleData.h>
#include <terralib/datatype/StringProperty.h>

const std::string ta::model::Process::sm_id("id");
const std::string ta::model::Process::sm_tasklogId("tasklog_id");
const std::string ta::model::Process::sm_taskId("task_id");

ta::model::Process::Process()
  : AbstractItem(),
  m_taskLogId(-1),
  m_taskId(-1)
{

}

ta::model::Process::~Process()
{
}

ta::model::ItemPropertyVector ta::model::Process::toProperties()
{
  ta::model::ItemPropertyVector ipv;

  {
    te::dt::Property* p = new te::dt::SimpleProperty(ta::model::Process::sm_tasklogId, te::dt::INT32_TYPE);
    te::dt::AbstractData* ad = new te::dt::SimpleData<int, te::dt::INT32_TYPE>(m_taskLogId);
    ta::model::ItemProperties* mep = new ta::model::ItemProperties(ta::model::Process::sm_tasklogId);
    mep->setProperty(p);
    mep->setData(ad);

    addProperty(ta::model::Process::sm_tasklogId, mep, ipv);
  }

  {
    te::dt::Property* p = new te::dt::SimpleProperty(ta::model::Process::sm_taskId, te::dt::INT32_TYPE);
    te::dt::AbstractData* ad = new te::dt::SimpleData<int, te::dt::INT32_TYPE>(m_taskId);
    ta::model::ItemProperties* mep = new ta::model::ItemProperties(ta::model::Process::sm_taskId);
    mep->setProperty(p);
    mep->setData(ad);

    addProperty(ta::model::Process::sm_taskId, mep, ipv);
  }

  return ipv;
}

int ta::model::Process::getId()
{
  return m_id;
}

int ta::model::Process::getTaskLogId()
{
  return m_taskLogId;
}

int ta::model::Process::getTaskId()
{
  return m_taskId;
}

void ta::model::Process::setId(int newId)
{
  m_id = newId;
}

void ta::model::Process::setTaskLogId(int newtaskLogId)
{
  m_taskLogId = newtaskLogId;
}

void ta::model::Process::setTaskId(int newtaskId)
{
  m_taskId = newtaskId;
}