/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/Process.h

\brief This file defines the Process model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_PROCESS_H
#define __TERRAAMAZON_MODEL_ITEM_PROCESS_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace te
{
  namespace dt
  {
    class Date;
  }
}

namespace ta
{
  namespace model
  {
    /*!
    \class Process

    \brief This class defines the project model.

    \ingroup model

    \sa AbstractItem
    */
    class Process : public AbstractItem
    {
      public:

        static const std::string sm_id;           //!< ...
        static const std::string sm_tasklogId;    //!< ...
        static const std::string sm_taskId;       //!< ...

      public:

        /*! \brief Default constructor  */
        Process();

        /*! \brief Default destructor  */
        ~Process();

      public:

        ItemPropertyVector toProperties();

      public:

        /** @name Getters
        */
        //@{

        int getId();
        int getTaskLogId();
        int getTaskId();

        //@}

        /** @name Setters
        */
        //@{

        void setId(int newId);
        void setTaskLogId(int newtaskLogId);
        void setTaskId(int newtaskId);

      //@}

      private:

        int                   m_taskLogId;
        int                   m_taskId;
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_PROCESS_H

