/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/Rule.h

\brief This file defines the Rule model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_RULE_H
#define __TERRAAMAZON_MODEL_ITEM_RULE_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class Rule

    \brief This class defines the rule model.

    \ingroup model

    \sa AbstractItem
    */
    class Rule : public AbstractItem
    {
      public:

        static const std::string sm_id;             //!< ...
        static const std::string sm_name;           //!< ...
        static const std::string sm_catalog_id;     //!< ...
        static const std::string sm_operation_id;    //!< ...

      public:

        /*! \brief Default constructor  */
        Rule();

        /*! \brief Default destructor  */
        ~Rule();

      public:

        ItemPropertyVector toProperties();

      public:

        /** @name Getters
        */
        //@{

        /*!
        \brief ...

        \return ...
        */
        std::string getName();

        /*!
        \brief ...

        \return ...
        */
        int getCatalogId();

        /*!
        \brief ...

        \return ...
        */
        int getOperationId();

        //@}

        /** @name Setters
        */
        //@{

        /*!
        \brief ...

        \param ...
        */
        void setName(const std::string& name);

        /*!
        \brief ...

        \param ...
        */
        void setCatalogId(const int& id);

        /*!
        \brief ...

        \param ...
        */
        void setOperationId(const int& id);

      //@}

      private:

        std::string            m_name;        //!< ...
        int                    m_catalogId;   //!< ...
        int                    m_operationId; //!< ...
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_RULE_H

