/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/RuleRuleSet.h

\brief This file defines the RuleRuleSet model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_RULERULESET_H
#define __TERRAAMAZON_MODEL_ITEM_RULERULESET_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class RuleRuleSet

    \brief This class defines the rule model.

    \ingroup model

    \sa AbstractItem
    */
    class RuleRuleSet : public AbstractItem
    {
      public:

        static const std::string sm_ruleset_id;   //!< ...
        static const std::string sm_rule_id;      //!< ...
        static const std::string sm_priority;     //!< ...


      public:

        /*! \brief Default constructor  */
        RuleRuleSet();

        /*! \brief Default destructor  */
        ~RuleRuleSet();

      public:

        ItemPropertyVector toProperties();

      public:

        /** @name Getters
        */
        //@{

        /*!
        \brief ...

        \return ...
        */
        int getRuleSetId();

        /*!
        \brief ...

        \return ...
        */
        int getRuleId();

        /*!
        \brief ...

        \return ...
        */
        int getPriority();

        
        //@}

        /** @name Setters
        */
        //@{

        /*!
        \brief ...

        \param ...
        */
        void setRuleSetId(const int& id);

        /*!
        \brief ...

        \param ...
        */
        void setRuleId(const int& id);

        /*!
        \brief ...

        \param ...
        */
        void setPriority(const int& priority);

      //@}

      private:

        int                    m_ruleSetId;  //!< ...
        int                    m_ruleId;     //!< ...
        int                    m_priority;   //!< ...
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_RULERULESET_H

