/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/RuleSet.h

\brief This file defines the RuleSet model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_RULESET_H
#define __TERRAAMAZON_MODEL_ITEM_RULESET_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class RuleSet

    \brief This class defines the rule model.

    \ingroup model

    \sa AbstractItem
    */
    class RuleSet : public AbstractItem
    {
      public:

        static const std::string sm_id;             //!< ...
        static const std::string sm_name;           //!< ...
        static const std::string sm_catalog_id;     //!< ...

      public:

        /*! \brief Default constructor  */
        RuleSet();

        /*! \brief Default destructor  */
        ~RuleSet();

      public:

        ItemPropertyVector toProperties();

      public:

        /** @name Getters
        */
        //@{

        /*!
        \brief ...

        \return ...
        */
        std::string getName();

        /*!
        \brief ...

        \return ...
        */
        int getCatalogId();

        //@}

        /** @name Setters
        */
        //@{

        /*!
        \brief ...

        \param ...
        */
        void setName(const std::string& name);

        /*!
        \brief ...

        \param ...
        */
        void setCatalogId(const int& id);

      //@}

      private:

        std::string            m_name;        //!< ...
        int                    m_catalogId;   //!< ...
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_RULESET_H

