/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/RulesLayerColumn.h

\brief This file defines the RulesLayerColumn model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_RULESLAYERCOLUMN_H
#define __TERRAAMAZON_MODEL_ITEM_RULESLAYERCOLUMN_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class RulesLayerColumn

    \brief This class defines the rule model.

    \ingroup model

    \sa AbstractItem
    */
    class RulesLayerColumn : public AbstractItem
    {
      public:

        static const std::string sm_id;          //!< ...
        static const std::string sm_column_in;   //!< ...
        static const std::string sm_column_out;  //!< ...
        static const std::string sm_rule_id;     //!< ...
        static const std::string sm_ruleset_id;  //!< ...

      public:

        /*! \brief Default constructor  */
        RulesLayerColumn();

        /*! \brief Default destructor  */
        ~RulesLayerColumn();

      public:

        ItemPropertyVector toProperties();

      public:

        /** @name Getters
        */
        //@{

        /*!
        \brief ...

        \return ...
        */
        std::string getColumnIn();

        /*!
        \brief ...

        \return ...
        */
        std::string getColumnOut();

        /*!
        \brief ...

        \return ...
        */
        int getRuleId();

        /*!
        \brief ...

        \return ...
        */
        int getRulesetId();

        //@}

        /** @name Setters
        */
        //@{

        /*!
        \brief ...

        \param ...
        */
        void setColumnIn(const std::string& name);

        /*!
        \brief ...

        \param ...
        */
        void setColumnOut(const std::string& name);

        /*!
        \brief ...

        \param ...
        */
        void setRuleId(const int& id);

        /*!
        \brief ...

        \param ...
        */
        void setRulesetId(const int& id);

      //@}

      private:

        std::string            m_columnIn;       //!< ...
        std::string            m_columnOut;      //!< ...
        int                    m_ruleId;         //!< ...
        int                    m_rulesetId;      //!< ...
    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_RULESLAYERCOLUMN_H

