/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item/RulesLayerParams.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_RULES_LAYER_PARAMS_H
#define __TERRAAMAZON_MODEL_ITEM_RULES_LAYER_PARAMS_H

// TerraAmazon
#include "AbstractItem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class RulesLayerParams

    \brief

    \ingroup model

    \sa AbstractItem
    */
    class RulesLayerParams : public AbstractItem
    {
      public:

        static const std::string sm_catalogId;      //!< ...
        static const std::string sm_classColumn;  //!< ...

      public:

        /*! \brief Default constructor  */
        RulesLayerParams();

        /*! \brief Default destructor  */
        ~RulesLayerParams();

      public:

        ItemPropertyVector toProperties();

      public:
        /** @name Getters
        */
        //@{

        int getCatalogId();
        std::string getClassColumn();

        //@}

        /** @name Setters
        */
        //@{

        void setCatalogId(const int& newCatalogId);
        void setClassColumn(const std::string& newClassColumn);

        //@}

      private:

        int          m_catalogId;    //!< ...
        std::string  m_classColumn;  //!< ...

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_RULES_LAYER_PARAMS_H

