/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item_mem/CatalogMem.h

\brief This file defines the CatalogMem model.
*/

// TerraAmazon
#include "CatalogMem.h"

// TerraLib


const std::string ta::model::CatalogMem::sm_rulesLayerParamsMems("ruleslayerparamsmems");
const std::string ta::model::CatalogMem::sm_cellLayerMem("celllayermem");
const std::string ta::model::CatalogMem::sm_aoiLayerMems("aoilayermems");

ta::model::CatalogMem::CatalogMem()
: Catalog()
{
}

ta::model::CatalogMem::~CatalogMem()
{
}

std::vector<ta::model::RulesLayerParamsMem*>& ta::model::CatalogMem::getRulesLayerParamsMems()
{
  return m_rulesLayerParamsMems;
}

ta::model::CellLayerMem* ta::model::CatalogMem::getCellLayerMem()
{
  return m_cellLayerMem;
}

std::vector<ta::model::AoiLayerMem*>& ta::model::CatalogMem::getAoiLayerMems()
{
  return m_aoiLayerMems;
}

void ta::model::CatalogMem::setRulesLayerParamsMems(std::vector<ta::model::RulesLayerParamsMem*> rulesLayerParamsMems)
{
  m_rulesLayerParamsMems = rulesLayerParamsMems;
}

void ta::model::CatalogMem::setCellLayerMem(ta::model::CellLayerMem* cellLayerMem)
{
  m_cellLayerMem = cellLayerMem;
}

void ta::model::CatalogMem::setAoiLayerMems(std::vector<ta::model::AoiLayerMem*> aoiLayerMems)
{
  m_aoiLayerMems = aoiLayerMems;
}
