/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item_mem/CatalogMem.h

\brief This file defines the CatalogMem model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_MEM_CATALOG_MEM_H
#define __TERRAAMAZON_MODEL_ITEM_MEM_CATALOG_MEM_H

// TerraAmazon
#include "../item/Catalog.h"
#include "../item_mem/AoiLayerMem.h"
#include "../item_mem/CellLayerMem.h"
#include "../item_mem/RulesLayerParamsMem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class CatalogMem

    \brief This class defines the CatalogMem model.

    \ingroup model

    \sa Catalog
    */
    class CatalogMem : public Catalog
    {
    public:

      static const std::string sm_rulesLayerParamsMems;       //!< ...
      static const std::string sm_cellLayerMem;               //!< ...
      static const std::string sm_aoiLayerMems;               //!< ...

    public:

      /*! \brief Default constructor  */
      CatalogMem();

      /*! \brief Default destructor  */
      ~CatalogMem();

    public:

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      std::vector<ta::model::RulesLayerParamsMem*>& getRulesLayerParamsMems();

      /*!
      \brief ...

      \return ...
      */
      ta::model::CellLayerMem* getCellLayerMem();

      /*!
      \brief ...

      \return ...
      */
      std::vector<ta::model::AoiLayerMem*>& getAoiLayerMems();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setRulesLayerParamsMems(std::vector<ta::model::RulesLayerParamsMem*> rulesLayerParamsMems);

      /*!
      \brief ...

      \param ...
      */
      void setCellLayerMem(ta::model::CellLayerMem* cellLayerMem);

      /*!
      \brief ...

      \param ...
      */
      void setAoiLayerMems(std::vector<ta::model::AoiLayerMem*> aoiLayerMems);

      //@}

    private:

      std::vector<ta::model::RulesLayerParamsMem*> m_rulesLayerParamsMems;     //!< ...
      ta::model::CellLayerMem* m_cellLayerMem;                                 //!< ...
      std::vector<ta::model::AoiLayerMem*> m_aoiLayerMems;                     //!< ...

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_MEM_CATALOG_MEM_H

