/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item_mem/ProjectMem.h

\brief This file defines the ProjectMem model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_MEM_PROJECT_MEM_H
#define __TERRAAMAZON_MODEL_ITEM_MEM_PROJECT_MEM_H

// TerraAmazon
#include "../item/Project.h"
#include "../item_mem/RuleSetMem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class ProjectMem

    \brief This class defines the ProjectMem model.

    \ingroup model

    \sa Project
    */
    class ProjectMem : public Project
    {
    public:

      static const std::string sm_ruleSetMems;       //!< ...

    public:

      /*! \brief Default constructor  */
      ProjectMem();

      /*! \brief Default destructor  */
      ~ProjectMem();

    public:

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      std::vector<ta::model::RuleSetMem*>& getRuleSetMems();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setRuleSetMems(std::vector<ta::model::RuleSetMem*> ruleSetMems);

      //@}

    private:

      std::vector<ta::model::RuleSetMem*> m_ruleSetMems;       //!< ...

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_MEM_PROJECT_MEM_H

