/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item_mem/RuleMem.h

\brief This file defines the RuleMem model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_MEM_RULE_MEM_H
#define __TERRAAMAZON_MODEL_ITEM_MEM_RULE_MEM_H

// TerraAmazon
#include "../item/Rule.h"
#include "../item_mem/CatalogMem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class RuleMem

    \brief This class defines the RuleMem model.

    \ingroup model

    \sa Rule
    */
    class RuleMem : public Rule
    {
    public:

      static const std::string sm_catalogMem;       //!< ...

    public:

      /*! \brief Default constructor  */
      RuleMem();

      /*! \brief Default destructor  */
      ~RuleMem();

    public:

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      ta::model::CatalogMem* getCatalogMem();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setCatalogMem(ta::model::CatalogMem* catalogMem);

      //@}

    private:

      ta::model::CatalogMem* m_catalogMem;                  //!< ...

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_MEM_RULE_MEM_H

