/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item_mem/RuleSetMem.h

\brief This file defines the RuleSetMem model.
*/

// TerraAmazon
#include "RuleSetMem.h"

// TerraLib

const std::string ta::model::RuleSetMem::sm_catalogMem("catalogmem");
const std::string ta::model::RuleSetMem::sm_classMems("classmems");
const std::string ta::model::RuleSetMem::sm_ruleStructMems("rulestructmems");

ta::model::RuleSetMem::RuleSetMem()
: RuleSet()
{
}

ta::model::RuleSetMem::~RuleSetMem()
{
}

ta::model::CatalogMem* ta::model::RuleSetMem::getCatalogMem()
{
  return m_catalogMem;
}

std::vector<ta::model::ClassMem*>& ta::model::RuleSetMem::getClassMems()
{
  return m_classMems;
}

std::vector<ta::model::RuleStructMem*>& ta::model::RuleSetMem::getRuleStructMems()
{
  return m_ruleStructMems;
}

void ta::model::RuleSetMem::setCatalogMem(ta::model::CatalogMem* catalogMem)
{
  m_catalogMem = catalogMem;
}

void ta::model::RuleSetMem::setClassMems(std::vector<ta::model::ClassMem*> classMems)
{
  m_classMems = classMems;
}

void ta::model::RuleSetMem::setRuleStructMems(std::vector<ta::model::RuleStructMem*> ruleStructMems)
{
  m_ruleStructMems = ruleStructMems;
}