/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item_mem/RuleSetMem.h

\brief This file defines the RuleSetMem model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_MEM_RULESET_MEM_H
#define __TERRAAMAZON_MODEL_ITEM_MEM_RULESET_MEM_H

// TerraAmazon
#include "../item/RuleSet.h"
#include "../item_mem/CatalogMem.h"
#include "../item_mem/ClassMem.h"
#include "../item_mem/RuleStructMem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class RuleSetMem

    \brief This class defines the RuleSetMem model.

    \ingroup model

    \sa RuleSet
    */
    class RuleSetMem : public RuleSet
    {
    public:

      static const std::string sm_catalogMem;       //!< ...
      static const std::string sm_classMems;        //!< ...
      static const std::string sm_ruleStructMems;   //!< ...

    public:

      /*! \brief Default constructor  */
      RuleSetMem();

      /*! \brief Default destructor  */
      ~RuleSetMem();

    public:

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      ta::model::CatalogMem* getCatalogMem();

      /*!
      \brief ...

      \return ...
      */
      std::vector<ta::model::ClassMem*>& getClassMems();

      /*!
      \brief ...

      \return ...
      */
      std::vector<ta::model::RuleStructMem*>& getRuleStructMems();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setCatalogMem(ta::model::CatalogMem* catalogMem);

      /*!
      \brief ...

      \param ...
      */
      void setClassMems(std::vector<ta::model::ClassMem*> classMems);

      /*!
      \brief ...

      \param ...
      */
      void setRuleStructMems(std::vector<ta::model::RuleStructMem*> ruleStructMems);

      //@}

    private:

      ta::model::CatalogMem* m_catalogMem;                          //!< ...
      std::vector<ta::model::ClassMem*> m_classMems;                //!< ...
      std::vector<ta::model::RuleStructMem*> m_ruleStructMems;      //!< ...

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_MEM_RULESET_MEM_H

