/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/item_mem/RuleStructMem.h

\brief This file defines the RuleStructMem model.
*/

#ifndef __TERRAAMAZON_MODEL_ITEM_MEM_RULESTRUCT_MEM_H
#define __TERRAAMAZON_MODEL_ITEM_MEM_RULESTRUCT_MEM_H

// TerraAmazon
#include "../item_mem/RuleMem.h"
#include "../item_mem/RulesLayerColumnMem.h"

// STL
#include <string>

namespace ta
{
  namespace model
  {
    /*!
    \class RuleStructMem

    \brief This class defines the RuleStructMem model.

    \ingroup model

    \sa RuleStruct
    */
    class RuleStructMem
    {
    public:

      static const std::string sm_ruleMem;               //!< ...
      static const std::string sm_priority;              //!< ...
      static const std::string sm_rulesLayerColumnMems;  //!< ...

    public:

      /*! \brief Default constructor  */
      RuleStructMem();

      /*! \brief Default destructor  */
      ~RuleStructMem();

      /** @name Getters
      */
      //@{

      /*!
      \brief ...

      \return ...
      */
      ta::model::RuleMem* getRuleMem();

      /*!
      \brief ...

      \return ...
      */
      int getPriority();

      /*!
      \brief ...

      \return ...
      */
      std::vector<ta::model::RulesLayerColumnMem*>& getRulesLayerColumnMems();

      //@}

      /** @name Setters
      */
      //@{

      /*!
      \brief ...

      \param ...
      */
      void setRuleMem(ta::model::RuleMem* ruleMem);

      /*!
      \brief ...

      \param ...
      */
      void setPriority(int priority);

      /*!
      \brief ...

      \param ...
      */
      void setRulesLayerColumnMems(std::vector<ta::model::RulesLayerColumnMem*> rulesLayerColumnMems);
      //@}

    private:

      ta::model::RuleMem* m_ruleMem;                                            //!< ...
      int m_priority;                                                           //!< ...
      std::vector<ta::model::RulesLayerColumnMem*> m_rulesLayerColumnMems;      //!< ...

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_ITEM_MEM_RULESTRUCT_MEM_H

