/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

#include <terralib/common/PlatformUtils.h>

// TerraAmazon
#include "GroupControlWidget.h"
#include "GroupControlDialog.h"
#include "ui_GroupControlDialogForm.h"

#include "../../../common/Utils.h"

ta::model::qt::GroupControlDialog::GroupControlDialog(QWidget* parent, Qt::WindowFlags f)
  : QDialog(parent, f),
  m_ui(new Ui::GroupControlDialogForm)
{
  m_ui->setupUi(this);

  std::string icon = ta::common::FindInTerraAmazonPath("share/icons/svg/terraAmazom-colorido-horizontal.svg");
  m_ui->m_imgLabel->setPixmap(QIcon(icon.c_str()).pixmap(112, 100));
  m_ui->m_imgLabel->hide();

  QGridLayout* layout = new QGridLayout(m_ui->m_groupWidget);
  layout->setContentsMargins(0, 0, 0, 0);

  m_widget = new GroupControlWidget(m_ui->m_groupWidget);

  layout->addWidget(m_widget);
  m_widget->adjustSize();
  this->adjustSize();
}

ta::model::qt::GroupControlDialog::~GroupControlDialog()
{
}

void ta::model::qt::GroupControlDialog::setServer(te::da::DataSourceInfoPtr server)
{
  m_widget->setServer(server);
}

