/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
\file terraamazon/GroupControlDialog.h

\brief A Qt dialog used to configure the application groups.
*/

#ifndef __TERRAAMAZON_MODEL_QT_ACCESSCONTROL_GROUPCONTROLDIALOG_H
#define __TERRAAMAZON_MODEL_QT_ACCESSCONTROL_GROUPCONTROLDIALOG_H

// TerraAmazon
#include "Config.h"

// Terralib
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class GroupControlDialogForm; }

namespace ta
{
  namespace model
  {
    namespace qt
    {
      //Forward declaration
      class GroupControlWidget;

      class GroupControlDialog : public QDialog
      {
        Q_OBJECT
      public:

        GroupControlDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~GroupControlDialog();

        void setServer(te::da::DataSourceInfoPtr server);

      private:
        std::unique_ptr<Ui::GroupControlDialogForm> m_ui;
        GroupControlWidget*                         m_widget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif // __TERRAAMAZON_MODEL_QT_ACCESSCONTROL_GROUPCONTROLDIALOG_H