/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

#include <terralib/common/PlatformUtils.h>

// TerraAmazon
#include "UserControlWidget.h"
#include "UserControlDialog.h"
#include "ui_UserControlDialogForm.h"

#include "../../../common/Utils.h"

ta::model::qt::UserControlDialog::UserControlDialog(QWidget* parent, Qt::WindowFlags f)
  : QDialog(parent, f),
  m_ui(new Ui::UserControlDialogForm)
{
  m_ui->setupUi(this);

  std::string icon = ta::common::FindInTerraAmazonPath("share/icons/svg/terraAmazom-colorido-horizontal.svg");
  m_ui->m_imgLabel->setPixmap(QIcon(icon.c_str()).pixmap(112, 100));
  m_ui->m_imgLabel->hide();

  QGridLayout* layout = new QGridLayout(m_ui->m_userWidget);
  layout->setContentsMargins(0, 0, 0, 0);

  m_widget = new UserControlWidget(m_ui->m_userWidget);

  layout->addWidget(m_widget);
  m_widget->adjustSize();
  this->adjustSize();
}

ta::model::qt::UserControlDialog::~UserControlDialog()
{
}

void ta::model::qt::UserControlDialog::setServer(te::da::DataSourceInfoPtr server)
{
  m_widget->setServer(server);
}

void ta::model::qt::UserControlDialog::setUser(int userId)
{
  m_widget->setUser(userId);
}
