/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
\file terraamazon/UserControlDialog.h

\brief A Qt dialog used to configure the application users.
*/

#ifndef __TERRAAMAZON_MODEL_QT_ACCESSCONTROL_USERCONTROLDIALOG_H
#define __TERRAAMAZON_MODEL_QT_ACCESSCONTROL_USERCONTROLDIALOG_H

// TerraAmazon
#include "Config.h"

// Terralib
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class UserControlDialogForm; }

namespace ta
{
  namespace model
  {
    namespace qt
    {
      //Forward declaration
      class UserControlWidget;

      class UserControlDialog : public QDialog
      {
        Q_OBJECT
      public:

        UserControlDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~UserControlDialog();

        void setServer(te::da::DataSourceInfoPtr server);

        void setUser(int userId);

      private:
        std::unique_ptr<Ui::UserControlDialogForm> m_ui;
        UserControlWidget*                         m_widget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif // __TERRAAMAZON_MODEL_QT_ACCESSCONTROL_USERCONTROLDIALOG_H