/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

#ifndef __TERRAAMAZON_MODEL_QT_CONCEPTUALMODEL_CREATECONCEPTUALMODELDIALOG_H
#define __TERRAAMAZON_MODEL_QT_CONCEPTUALMODEL_CREATECONCEPTUALMODELDIALOG_H

// TerraAmazon
#include "Config.h"
#include "../../../common/qt/CreateCellLayerWidget.h"

// TerraLib
#include <terralib/dataaccess/datasource/DataSourceInfo.h>
#include <terralib/maptools/AbstractLayer.h>

// STL
#include <string>

// Qt
#include <QDialog>

namespace Ui { class CreateConceptualModelDialogForm; }

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class CreateConceptualModelDialog : public QDialog
      {
        Q_OBJECT

      public:

        CreateConceptualModelDialog(QWidget* parent = 0);

        ~CreateConceptualModelDialog();

        ta::common::qt::CreateCellLayerWidget* getWidget();

        te::map::AbstractLayerPtr getCellLayer();

      protected slots:

        void onOkPushButtonClicked();

      private:

        std::unique_ptr<Ui::CreateConceptualModelDialogForm> m_ui;
        ta::common::qt::CreateCellLayerWidget* m_widget;

        te::da::DataSourceInfoPtr m_targetDs;
        std::string m_cellLayerName;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_CONCEPTUALMODEL_CREATECONCEPTUALMODELDIALOG_H
