/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/model/qt/conceptualModel/ProjectImportUtils.h

\brief
*/

#ifndef __TERRAAMAZON_MODEL_PROJECTIMPORTUTILS_H
#define __TERRAAMAZON_MODEL_PROJECTIMPORTUTILS_H

// TerraAmazon
#include "../../item_mem/ProjectMem.h"

// TerraLib
#include <terralib/dataaccess/datasource/DataSource.h>

namespace ta
{
  namespace model
  {
    class ProjectImportUtils
    {

    public:

      /*! Default Constructor */
      ProjectImportUtils();

      /*! \brief Virtual destructor. */
      ~ProjectImportUtils();

    public:

      bool importToDatabase(ta::model::ProjectMem* projectMem, std::string& errorMessage, std::string& warningMessage, te::da::DataSourcePtr& dataSource);

    private:

      bool importAuxCatalog(ta::model::CatalogMem* catalog, te::da::DataSourceTransactor* transactor, te::da::DataSourcePtr& dataSource);

    };
  } // end namespace model
}   // end namespace ta

#endif // __TERRAAMAZON_MODEL_PROJECTIMPORTUTILS_H