/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/AOIManagementWizard.h

  \brief A Qt wizard page used to management the AOI.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_AOIMANAGEMENTWIZARD_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_AOIMANAGEMENTWIZARD_H

// Terralib
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// Qt
#include <QWizard>

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class AOIControlProjectWizardPage;
      class AOIControlScenarioWizardPage;

      class AOIManagementWizard : public QWizard
      {
        Q_OBJECT

      public:

        AOIManagementWizard(QWidget* parent);

        ~AOIManagementWizard();

        virtual bool validateCurrentPage();

        void setServer(te::da::DataSourceInfoPtr server);

      protected:

        void addPages();

      private:

        enum
        {
          PAGE_SCENE_CONTROL,
          PAGE_PROJECT_CONTROL,
        };

        AOIControlProjectWizardPage*   m_projControlWizardPage;
        AOIControlScenarioWizardPage*  m_sceneControlWizardPage;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTMANAGEMENTWIZARD_H
