/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/AddNewTaskDialog.h

  \brief A Qt dialog used to configure the new tasks.
*/

#ifndef __TERRAAMAZON_MODEL_QT_TASK_ADDNEWTASKDIALOG_H
#define __TERRAAMAZON_MODEL_QT_TASK_ADDNEWTASKDIALOG_H

// TerraAmazon
#include "Config.h"

// Terralib
#include <terralib/dataaccess/datasource/DataSource.h>
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// TerraAmazon
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class AddNewTaskDialogForm; }

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class AddNewTaskDialog : public QDialog
      {
        Q_OBJECT
          public:

            AddNewTaskDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

            ~AddNewTaskDialog();

            void setTask(te::da::DataSourcePtr ds, const int& projId, const int& userId);

            bool hadAddedScene();

          protected slots:

            void onClosePushClicked();

            void onAddToolPushClicked();

            void onSceneTableClicked(int row, int col);

          private:

            std::auto_ptr<Ui::AddNewTaskDialogForm> m_ui;

            te::da::DataSourcePtr m_server;

            int m_projId;

            int m_userId;

            bool m_hadAddedScene;

            void init();

            void listScenes();

      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_TASK_ADDNEWTASKDIALOG_H

