/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

/*!
\file terraamazon/AttributeControlDialog.h

\brief A Qt dialog used to configure the attribute control.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_ATTRIBUTECONTROLDIALOG_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_ATTRIBUTECONTROLDIALOG_H

// TerraAmazon
#include "Config.h"
#include "AttributeControlWidget.h"

// Terralib
#include <terralib/dataaccess/datasource/DataSource.h>
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class AttributeControlDialogForm; }

namespace ta
{
  namespace model
  {

    namespace qt
    {

      class AttributeControlDialog : public QDialog
      {
        Q_OBJECT
      public:

        AttributeControlDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~AttributeControlDialog();

        void setServer(te::da::DataSourceInfoPtr dsInfo);

      public:

        AttributeControlWidget* getWidget();

      private:

        te::da::DataSourcePtr                           m_activeServer;      //!< The active server selected by the user.
        std::unique_ptr<Ui::AttributeControlDialogForm>           m_ui;      //!< The widget's form.
        AttributeControlWidget* m_widget;

      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_ATTRIBUTECONTROLDIALOG_H
