/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/AttributeControlWizardPage.cpp

  \brief A Qt wizard page used to configure the project settings.
*/

// TerraLib
#include "AttributeControlWidget.h"
#include "AttributeControlWizardPage.h"

// Qt
#include <QGridLayout>


ta::model::qt::AttributeControlWizardPage::AttributeControlWizardPage(QWidget* parent)
  : QWizardPage(parent)
{
  QGridLayout* layout = new QGridLayout(this);
  layout->setContentsMargins(0, 0, 0, 0);

  m_widget = new AttributeControlWidget(this);

  layout->addWidget(m_widget);

  //configure page
  this->setTitle(tr("Attribute Control"));
  this->setSubTitle(tr("Allows the user to manage rules of a project of TerraAmazon application."));
}

ta::model::qt::AttributeControlWizardPage::~AttributeControlWizardPage()
{
}

bool ta::model::qt::AttributeControlWizardPage::isComplete() const
{
  return true;
}

ta::model::qt::AttributeControlWidget* ta::model::qt::AttributeControlWizardPage::getWidget() const
{
  return m_widget;
}