/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/AttributeControlWizardPage.h

  \brief A Qt wizard page used to configure the project settings.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_ATTRIBUTECONTROLWIZARDPAGE_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_ATTRIBUTECONTROLWIZARDPAGE_H

// STL
#include <memory>

// Qt
#include <QWizardPage>

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class AttributeControlWidget;

      class AttributeControlWizardPage : public QWizardPage
      {
        Q_OBJECT

      public:

        AttributeControlWizardPage(QWidget* parent = 0);

        virtual ~AttributeControlWizardPage();

        bool isComplete() const;

        AttributeControlWidget* getWidget() const;

      private:

        AttributeControlWidget* m_widget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_ATTRIBUTECONTROLWIZARDPAGE_H

