/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
\file terraamazon/ClassControlDialog.cpp

\brief A Qt dialog used to configure the class settings.
*/

// TerraAmazon
#include "ClassControlDialog.h"
#include "ClassControlWidget.h"
#include "ui_ClassControlDialogForm.h"

#include "../../../common/Utils.h"

// Qt
#include <QGridLayout>

ta::model::qt::ClassControlDialog::ClassControlDialog(QWidget* parent, Qt::WindowFlags f)
  : QDialog(parent, f),
  m_ui(new Ui::ClassControlDialogForm)
{
  m_ui->setupUi(this);

  std::string icon = ta::common::FindInTerraAmazonPath("share/icons/svg/terraAmazom-colorido-horizontal.svg");
  m_ui->m_imgLabel->setPixmap(QIcon(icon.c_str()).pixmap(112, 100));
  m_ui->m_imgLabel->hide();

  QGridLayout* layout = new QGridLayout(m_ui->m_widget);
  layout->setContentsMargins(0, 0, 0, 0);

  m_ccWidget = new ClassControlWidget(m_ui->m_widget);

  layout->addWidget(m_ccWidget);

}

ta::model::qt::ClassControlDialog::~ClassControlDialog()
{
}

void ta::model::qt::ClassControlDialog::setActiveServer(te::da::DataSourceInfoPtr dsInfo)
{
  m_ccWidget->setActiveServer(dsInfo);

  this->setWindowTitle(m_ccWidget->windowTitle());
}