/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ClassControlDialog.h

  \brief A Qt dialog used to configure the class settings.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_CLASSCONTROLDIALOG_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_CLASSCONTROLDIALOG_H

// TerraAmazon
#include "Config.h"

// Terralib
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class ClassControlDialogForm; }

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class ClassControlWidget;

      class ClassControlDialog : public QDialog
      {
        Q_OBJECT
      public:

        ClassControlDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~ClassControlDialog();

      public:

        void setActiveServer(te::da::DataSourceInfoPtr dsInfo);

      private:
        std::auto_ptr<Ui::ClassControlDialogForm> m_ui;

        ClassControlWidget* m_ccWidget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_CLASSCONTROLDIALOG_H

