/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ClassControlWizardPage.cpp

  \brief A Qt wizard page used to configure the project settings.
*/

// TerraLib
#include "ClassControlWidget.h"
#include "ClassControlWizardPage.h"

// Qt
#include <QGridLayout>


ta::model::qt::ClassControlWizardPage::ClassControlWizardPage(QWidget* parent)
  : QWizardPage(parent)
{
  QGridLayout* layout = new QGridLayout(this);
  layout->setContentsMargins(0, 0, 0, 0);

  m_widget = new ClassControlWidget(this);

  layout->addWidget(m_widget);

  //configure page
  this->setTitle(tr("Class Control"));
  this->setSubTitle(tr("Allows the user to manage classes of a project of TerraAmazon application."));
}

ta::model::qt::ClassControlWizardPage::~ClassControlWizardPage()
{
}

bool ta::model::qt::ClassControlWizardPage::isComplete() const
{
  return true;
}

ta::model::qt::ClassControlWidget* ta::model::qt::ClassControlWizardPage::getWidget() const
{
  return m_widget;
}