/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ClassControlWizardPage.h

  \brief A Qt wizard page used to configure the project settings.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_CLASSCONTROLWIZARDPAGE_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_CLASSCONTROLWIZARDPAGE_H

// STL
#include <memory>

// Qt
#include <QWizardPage>

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class ClassControlWidget;

      class ClassControlWizardPage : public QWizardPage
      {
        Q_OBJECT

      public:

        ClassControlWizardPage(QWidget* parent = 0);

        virtual ~ClassControlWizardPage();

        bool isComplete() const;

        ClassControlWidget* getWidget() const;

      private:

        ClassControlWidget* m_widget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_CLASSCONTROLWIZARDPAGE_H

