/*  This file is part of the TerraAmazon application.

See the Copyright file for details about the license of
this application.
*/

#ifndef __TERRAAMAZON_MODEL_QT_LOCKEDCELLSWIDGET_H
#define __TERRAAMAZON_MODEL_QT_LOCKEDCELLSWIDGET_H

// TerraAmazon
#include "Config.h"
#include "../../facade/CatalogFacade.h"
#include "../../facade/UserFacade.h"
#include "../../facade/ProcessFacade.h"

// TerraLib
#include <terralib/dataaccess/datasource/DataSource.h>
#include <terralib/dataaccess/datasource/DataSourceInfo.h>
#include <terralib/maptools/AbstractLayer.h>

// STL
#include <string>

// Qt
#include <QDialog>

namespace Ui { class LockedCellsWidgetForm; }

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class LockedCellsWidget : public QWidget
      {
        Q_OBJECT

      public:

        LockedCellsWidget(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~LockedCellsWidget();

        void setServer(te::da::DataSourceInfoPtr dsInfo);

      protected:

        void listUsers();

        void listLockedCells();

        protected slots :

        void onApplyToolButtonClicked();

        void onClearToolButtonClicked();

        void onUnlockCellsPushButtonClicked();

      private:

        te::da::DataSourcePtr                         m_activeServer;
        int                                           m_activeCellLayer;
        std::auto_ptr<Ui::LockedCellsWidgetForm>      m_ui;
        std::unique_ptr<ta::model::CatalogFacade>     m_catalogFacade;
        std::unique_ptr<ta::model::UserFacade>        m_userFacade;
        std::unique_ptr<ta::model::ProcessFacade>     m_processFacade;

      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_LOCKEDCELLSWIDGET_H
