/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ProjectActivationDialog.h

  \brief A Qt dialog used to configure the project settings.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTACTIVATIONDIALOG_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTACTIVATIONDIALOG_H

// TerraAmazon
#include "Config.h"

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class ProjectActivationDialogForm; }

namespace ta
{
  namespace model
  {
    class Project;

    namespace qt
    {
      class ProjectActivationWidget;

      class ProjectActivationDialog : public QDialog
      {
        Q_OBJECT
      public:

        ProjectActivationDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~ProjectActivationDialog();

        void setServer(te::da::DataSourceInfoPtr dsInfo);

        int getActiveProjectId();

        void setActiveProjectId(int projId);

      public:

        ProjectActivationWidget* getWidget();

      private:

        std::auto_ptr<Ui::ProjectActivationDialogForm> m_ui;

        ProjectActivationWidget* m_widget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTACTIVATIONDIALOG_H

