/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ProjectControlDialog.cpp

  \brief A Qt dialog used to configure the project settings.
*/

// TerraAmazon
#include "ProjectControlWidget.h"
#include "ProjectControlDialog.h"
#include "ui_ProjectControlDialogForm.h"

#include "../../../common/Utils.h"

// Qt
#include <QGridLayout>

ta::model::qt::ProjectControlDialog::ProjectControlDialog(QWidget* parent, Qt::WindowFlags f)
  : QDialog(parent, f),
  m_ui(new Ui::ProjectControlDialogForm)
{
  m_ui->setupUi(this);

  std::string icon = ta::common::FindInTerraAmazonPath("share/icons/svg/terraAmazom-colorido-horizontal.svg");
  m_ui->m_imgLabel->setPixmap(QIcon(icon.c_str()).pixmap(112, 100));
  m_ui->m_imgLabel->hide();

  QGridLayout* layout = new QGridLayout(m_ui->m_widget);
  layout->setContentsMargins(0, 0, 0, 0);

  m_widget = new ProjectControlWidget(m_ui->m_widget);

  layout->addWidget(m_widget);

}

ta::model::qt::ProjectControlDialog::~ProjectControlDialog()
{
}

void ta::model::qt::ProjectControlDialog::setActiveServer(te::da::DataSourceInfoPtr dsInfo)
{
  m_widget->setActiveServer(dsInfo);
}
