/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ProjectControlDialog.h

  \brief A Qt dialog used to configure the project settings.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTCONTROLDIALOG_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTCONTROLDIALOG_H


// Terralib
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class ProjectControlDialogForm; }

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class ProjectControlWidget;

      class ProjectControlDialog : public QDialog
      {
        Q_OBJECT
      public:

        ProjectControlDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~ProjectControlDialog();

      public:

        void setActiveServer(te::da::DataSourceInfoPtr dsInfo);

      private:

        std::auto_ptr<Ui::ProjectControlDialogForm> m_ui;

        ProjectControlWidget* m_widget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTCONTROLDIALOG_H

