/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ProjectControlWizardPage.cpp

  \brief A Qt wizard page used to configure the project settings.
*/

// TerraLib
#include "ProjectControlWidget.h"
#include "ProjectControlWizardPage.h"

// Qt
#include <QGridLayout>


ta::model::qt::ProjectControlWizardPage::ProjectControlWizardPage(QWidget* parent)
  : QWizardPage(parent)
{
  QGridLayout* layout = new QGridLayout(this);
  layout->setContentsMargins(0, 0, 0, 0);

  m_widget = new ProjectControlWidget(this);

  layout->addWidget(m_widget);

  //configure page
  this->setTitle(tr("Project Management"));
  this->setSubTitle(tr("Allows the user to manage projects of TerraAmazon application."));
}

ta::model::qt::ProjectControlWizardPage::~ProjectControlWizardPage()
{
}

bool ta::model::qt::ProjectControlWizardPage::isComplete() const
{
  return true;
}

ta::model::qt::ProjectControlWidget* ta::model::qt::ProjectControlWizardPage::getWidget() const
{
  return m_widget;
}