/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ProjectControlWizardPage.h

  \brief A Qt wizard page used to configure the project settings.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTCONTROLWIZARDPAGE_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTCONTROLWIZARDPAGE_H

// STL
#include <memory>

// Qt
#include <QWizardPage>

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class ProjectControlWidget;

      class ProjectControlWizardPage : public QWizardPage
      {
        Q_OBJECT

      public:

        ProjectControlWizardPage(QWidget* parent = 0);

        virtual ~ProjectControlWizardPage();

        bool isComplete() const;

        ProjectControlWidget* getWidget() const;

      private:

        ProjectControlWidget* m_widget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_PROJECTCONTROLWIZARDPAGE_H

