/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/RulesControlDialog.h

  \brief A Qt dialog used to configure the project settings.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_RULESCONTROLDIALOG_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_RULESCONTROLDIALOG_H

// TerraAmazon
#include "Config.h"

// Terralib
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
#include <memory>

// Qt
#include <QDialog>

// Forward declaration
namespace Ui { class RulesControlDialogForm; }

namespace ta
{
  namespace model
  {
    class Project;

    namespace qt
    {
      class RulesControlWidget;

      class RulesControlDialog : public QDialog
      {
        Q_OBJECT
      public:

        RulesControlDialog(QWidget* parent = 0, Qt::WindowFlags f = 0);

        ~RulesControlDialog();

      public:

        void setActiveServer(te::da::DataSourceInfoPtr dsInfo);

        void setUser(const std::string& user);

      private:
        std::auto_ptr<Ui::RulesControlDialogForm> m_ui;

        RulesControlWidget* m_rcWidget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_RULESCONTROLDIALOG_H

