/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/RulesControlWizardPage.cpp

  \brief A Qt wizard page used to configure the project settings.
*/

// TerraLib
#include "RulesControlWidget.h"
#include "RulesControlWizardPage.h"

// Qt
#include <QGridLayout>


ta::model::qt::RulesControlWizardPage::RulesControlWizardPage(QWidget* parent)
  : QWizardPage(parent)
{
  QGridLayout* layout = new QGridLayout(this);
  layout->setContentsMargins(0, 0, 0, 0);

  m_widget = new RulesControlWidget(this);

  layout->addWidget(m_widget);

  //configure page
  this->setTitle(tr("Rules Control"));
  this->setSubTitle(tr("Allows the user to manage rules of a project of TerraAmazon application."));
}

ta::model::qt::RulesControlWizardPage::~RulesControlWizardPage()
{
}

bool ta::model::qt::RulesControlWizardPage::isComplete() const
{
  return true;
}

ta::model::qt::RulesControlWidget* ta::model::qt::RulesControlWizardPage::getWidget() const
{
  return m_widget;
}