/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/RulesControlWizardPage.h

  \brief A Qt wizard page used to configure the project settings.
*/

#ifndef __TERRAAMAZON_MODEL_QT_PROJECT_RULESCONTROLWIZARDPAGE_H
#define __TERRAAMAZON_MODEL_QT_PROJECT_RULESCONTROLWIZARDPAGE_H

// STL
#include <memory>

// Qt
#include <QWizardPage>

namespace ta
{
  namespace model
  {
    namespace qt
    {
      class RulesControlWidget;

      class RulesControlWizardPage : public QWizardPage
      {
        Q_OBJECT

      public:

        RulesControlWizardPage(QWidget* parent = 0);

        virtual ~RulesControlWizardPage();

        bool isComplete() const;

        RulesControlWidget* getWidget() const;

      private:

        RulesControlWidget* m_widget;
      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_PROJECT_RULESCONTROLWIZARDPAGE_H

