/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file terraamazon/ServerRegisterWidget.h

  \brief ...
*/

#ifndef __TERRAAMAZON_MODEL_QT_WORKSPACE_SERVERREGISTERWIDGET_H
#define __TERRAAMAZON_MODEL_QT_WORKSPACE_SERVERREGISTERWIDGET_H


// TerraLib
#include <terralib/dataaccess/datasource/DataSourceInfo.h>

// STL
//#include <memory>

// Qt
#include <QWidget>

// Forward declaration
namespace Ui { class ServerRegisterWidgetForm; }

namespace ta
{
  namespace workspace
  {
    namespace qt
    {
      class ServerRegisterWidget : public QWidget
      {
        Q_OBJECT

        public:

          ServerRegisterWidget(QWidget* parent = 0, Qt::WindowFlags f = 0);

          ~ServerRegisterWidget();

          std::string getHost();

          std::string getPort();

          std::string getUser();

          std::string getPassword();

          std::string getServerName();

          std::string getServerAlias();

          void setHost(const std::string& host);

          void setPort(const std::string& port);

          void setUser(const std::string& user);

          void setPassword(const std::string& password);

          void setServerName(const std::string& serverName);

          void setServerAlias(const std::string& serverAlias);

        protected slots:

          void onLoadServersPushButtonClicked();

        private:
          std::unique_ptr<Ui::ServerRegisterWidgetForm> m_ui;

      };
    } // end namespace qt
  }   // end namespace model
}     // end namespace ta

#endif  // __TERRAAMAZON_MODEL_QT_WORKSPACE_SERVERREGISTERWIDGET_H
