/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file WorkspaceWidget.h

  \brief A frame for setting project options.
*/

#ifndef __TERRAAMAZON_WORKSPACE_QT_WORKSPACEWIDGET_H
#define __TERRAAMAZON_WORKSPACE_QT_WORKSPACEWIDGET_H

// TerraLib
#include <terralib/BuildConfig.h>
#include <terralib/qt/af/settings/AbstractSettingWidget.h>

// Forwar declaration
namespace Ui 
{ 
  class WorkspaceWidgetForm; 
}

namespace ta
{
  namespace workspace
  {
    namespace qt
    {
      /*!
      \class WorkspaceWidget

      \brief A frame for setting grid options.
      */
      class WorkspaceWidget : public te::qt::af::AbstractSettingWidget
      {
        Q_OBJECT

      public:

        WorkspaceWidget(QWidget* parent = 0);

        ~WorkspaceWidget();

        void saveChanges();

        void resetState();

        virtual void getHelpInformations(QString& ns, QString& helpFile);

        protected slots:

        void authorChanged(const QString& text);

        void maxSavedChanged(int i);

        void onOpeningOptionChanged();

      private:

        Ui::WorkspaceWidgetForm* m_ui;
      };
    } // end namespace qt
  }   // end namespace workspace
}     // end namespace ta

#endif // __TERRAAMAZON_WORKSPACE_QT_WORKSPACEWIDGET_H
