/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

#include "WorkspaceWidget.h"
#include "WorkspaceWidgetFactory.h"

ta::workspace::qt::WorkspaceWidgetFactory* ta::workspace::qt::WorkspaceWidgetFactory::sm_factory(0);


void ta::workspace::qt::WorkspaceWidgetFactory::initialize()
{
  finalize();
  sm_factory = new WorkspaceWidgetFactory;
}

void ta::workspace::qt::WorkspaceWidgetFactory::finalize()
{
  delete sm_factory;
  sm_factory = 0;
}

ta::workspace::qt::WorkspaceWidgetFactory::~WorkspaceWidgetFactory()
{

}

te::qt::af::AbstractSettingWidget* ta::workspace::qt::WorkspaceWidgetFactory::build()
{
  return new WorkspaceWidget;
}

ta::workspace::qt::WorkspaceWidgetFactory::WorkspaceWidgetFactory() :
te::qt::af::SettingsWidgetsFactory(QObject::tr("Workspace").toStdString())
{

}

te::qt::af::AbstractSettingWidget* ta::workspace::qt::WorkspaceWidgetFactory::create(QWidget* parent)
{
  return new WorkspaceWidget(parent);
}