/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

/*!
  \file WorkspaceWidgetFactory.h

  \brief A factory to build the workspace frame object.
*/

#ifndef __TERRAAMAZON_WORKSPACE_QT_WORKSPACEWIDGETFACTORY_H
#define __TERRAAMAZON_WORKSPACE_QT_WORKSPACEWIDGETFACTORY_H

// TerraAmazon
#include "Config.h"

// TerraLib
#include <terralib/qt/af/settings/AbstractSettingWidget.h>
#include <terralib/qt/af/settings/SettingsWidgetsFactory.h>

// Forward declarations
class QWidget;

namespace ta
{
  namespace workspace
  {
    namespace qt
    {
      /*!
      \class WorkspaceWidgetFactory

      \brief A factory to build the workspace frame object.
      */
      class WorkspaceWidgetFactory : public te::qt::af::SettingsWidgetsFactory
      {
      public:

        static void initialize();

        static void finalize();

        ~WorkspaceWidgetFactory();

      protected:

        te::qt::af::AbstractSettingWidget* build();

        WorkspaceWidgetFactory();

        virtual te::qt::af::AbstractSettingWidget* create(QWidget* parent = 0);

      private:

        static WorkspaceWidgetFactory* sm_factory;
      };
    } // end namespace qt
  }   // end namespace workspace
}     // end namespace ta

#endif // __TERRAAMAZON_WORKSPACE_QT_WORKSPACEWIDGETFACTORY_H