/*  This file is part of the TerraAmazon application.

    See the Copyright file for details about the license of 
    this application.
 */

// TerraAmazon
#include "../Workspace.h"
#include "ui_WorkspaceInfoWidgetForm.h"
#include "WorkspaceInfoWidget.h"

ta::workspace::qt::WorkspaceInfoWidget::WorkspaceInfoWidget(QWidget* parent) :
  QWidget(parent),
  m_ws(0),
  m_ui(new Ui::WorkspaceInfoWidgetForm)
{
  m_ui->setupUi(this);
  m_ui->m_description->setEnabled(false);
}

ta::workspace::qt::WorkspaceInfoWidget::~WorkspaceInfoWidget()
{
}

void ta::workspace::qt::WorkspaceInfoWidget::setWorkspace(WorkspaceMetadata* ws)
{
  m_ws = ws;

  if(m_ws != 0)
  {
    m_ui->m_author->setText(m_ws->m_author);
    m_ui->m_title->setText(m_ws->m_title);
    m_ui->m_location->setText(m_ws->m_fileName);
  }
}

void ta::workspace::qt::WorkspaceInfoWidget::updateWorkspaceInfo()
{
  if(m_ws != 0)
  {
    m_ws->m_title = m_ui->m_title->text();
    m_ws->m_author = m_ui->m_author->text();
    m_ws->m_changed = true;
  }
}
